/**
* PeerTube
* # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ``` 
*
* The version of the OpenAPI document: 2.3.0
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/
package org.peertube.client.models

import org.peertube.client.models.AbuseStateConstant
import org.peertube.client.models.Account
import org.peertube.client.models.VideoAbuseVideo

import com.squareup.moshi.Json
/**
 * 
 * @param id 
 * @param reason 
 * @param predefinedReasons 
 * @param reporterAccount 
 * @param state 
 * @param moderationComment 
 * @param video 
 * @param createdAt 
 */

data class VideoAbuse (
    @Json(name = "id")
    val id: kotlin.Int? = null,
    @Json(name = "reason")
    val reason: kotlin.String? = null,
    @Json(name = "predefinedReasons")
    val predefinedReasons: kotlin.Array<VideoAbuse.PredefinedReasons>? = null,
    @Json(name = "reporterAccount")
    val reporterAccount: Account? = null,
    @Json(name = "state")
    val state: AbuseStateConstant? = null,
    @Json(name = "moderationComment")
    val moderationComment: kotlin.String? = null,
    @Json(name = "video")
    val video: VideoAbuseVideo? = null,
    @Json(name = "createdAt")
    val createdAt: java.time.OffsetDateTime? = null
) {

    /**
    * 
    * Values: violentOrAbusive,hatefulOrAbusive,spamOrMisleading,privacy,rights,serverRules,thumbnails,captions
    */
    
    enum class PredefinedReasons(val value: kotlin.String){
        @Json(name = "violentOrAbusive") violentOrAbusive("violentOrAbusive"),
        @Json(name = "hatefulOrAbusive") hatefulOrAbusive("hatefulOrAbusive"),
        @Json(name = "spamOrMisleading") spamOrMisleading("spamOrMisleading"),
        @Json(name = "privacy") privacy("privacy"),
        @Json(name = "rights") rights("rights"),
        @Json(name = "serverRules") serverRules("serverRules"),
        @Json(name = "thumbnails") thumbnails("thumbnails"),
        @Json(name = "captions") captions("captions");
    }
}

